## ros-lunar-teb-local-planner 0.7.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(teb_local_planner)

# Set to Release in order to speed up the program significantly
set(CMAKE_BUILD_TYPE Release) #None, Debug, Release, RelWithDebInfo, MinSizeRel

## Find catkin macros and libraries
find_package(catkin REQUIRED COMPONENTS
  base_local_planner
  costmap_2d
  costmap_converter
  cmake_modules
  dynamic_reconfigure
  geometry_msgs
  interactive_markers
  message_generation
  nav_core
  nav_msgs
  roscpp
  std_msgs
  pluginlib
  tf
  tf_conversions
  visualization_msgs
)
message(STATUS "System: ${CMAKE_SYSTEM}")
## System dependencies are found with CMake's conventions
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake_modules)
message(STATUS "${CMAKE_MODULE_PATH}")
find_package(Boost REQUIRED COMPONENTS system thread graph)
find_package(SUITESPARSE REQUIRED)
find_package(G2O REQUIRED)

# Eigen3 FindScript Backward compatibility (ubuntu saucy)
# Since FindEigen.cmake is deprecated starting from jade.
if (EXISTS "FindEigen3.cmake")
  find_package(Eigen3 REQUIRED)
  set(Eigen_INCLUDE_DIRS ${Eigen3_INCLUDE_DIRS})
elseif (EXISTS "FindEigen.cmake")
  find_package(Eigen REQUIRED)
elseif (EXISTS "FindEigen.cmake")
  message(WARNING "No findEigen cmake script found. You must provde one of them,
  e.g. by adding it to ${PROJECT_SOURCE_DIR}/cmake_modules.")
endif (EXISTS "FindEigen3.cmake")

set(EXTERNAL_INCLUDE_DIRS ${Eigen_INCLUDE_DIRS} ${SUITESPARSE_INCLUDE_DIRS} ${G2O_INCLUDE_DIR})
set(EXTERNAL_LIBS ${SUITESPARSE_LIBRARIES} ${G2O_LIBRARIES})

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()


## C++11 support
## Unfortunately, the 3d-party dependency libg2o requires c++11 starting from ROS Jade.
## Even if the ROS Jade specifications do not want c++11-only packages,
## we cannot compile without c++11 enabled. Another option would be to downgrade  
## libg2o third-party package.
## By now, if you do not want c++11, please refer to the ros indigo version.
IF(NOT MSVC)
  include(CheckCXXCompilerFlag)
  CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
  CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
  message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support which is required 
  by linked third party packages starting from ROS Jade. Ignore this message for ROS Indigo.")
endif()
endif()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend and a run_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependencies might have been
##     pulled in transitively but can be declared for certainty nonetheless:
##     * add a build_depend tag for "message_generation"
##     * add a run_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
add_message_files(
  FILES
  TrajectoryPointMsg.msg
  TrajectoryMsg.msg
  FeedbackMsg.msg
)

## Generate services in the 'srv' folder
# add_service_files(
#   FILES
#   Service1.srv
#   Service2.srv
# )

## Generate actions in the 'action' folder
# add_action_files(
#   FILES
#   Action1.action
#   Action2.action
# )

## Generate added messages and services with any dependencies listed here
generate_messages(
   DEPENDENCIES
   geometry_msgs std_msgs costmap_converter
)

#add dynamic reconfigure api
#find_package(catkin REQUIRED dynamic_reconfigure)
generate_dynamic_reconfigure_options(
  cfg/TebLocalPlannerReconfigure.cfg
)


###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include ${EXTERNAL_INCLUDE_DIRS}
  LIBRARIES teb_local_planner ${EXTERNAL_LIBS}
  CATKIN_DEPENDS
	base_local_planner
	costmap_2d
	costmap_converter
	dynamic_reconfigure
	geometry_msgs
	interactive_markers
	message_runtime
	nav_core
	nav_msgs
	pluginlib
	roscpp
	std_msgs
	tf
	tf_conversions
	visualization_msgs
  DEPENDS SUITESPARSE G2O
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
# include_directories(include)
include_directories(
  include
  ${EXTERNAL_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

## Build the teb_local_planner library

add_library(teb_local_planner
   src/timed_elastic_band.cpp
   src/optimal_planner.cpp
   src/obstacles.cpp
   src/visualization.cpp
   src/recovery_behaviors.cpp
   src/teb_config.cpp
   src/homotopy_class_planner.cpp
   src/teb_local_planner_ros.cpp
   src/graph_search.cpp
)

# Dynamic reconfigure: make sure configure headers are built before any node using them
add_dependencies(teb_local_planner ${PROJECT_NAME}_gencfg)
# Generate messages before compiling the lib
add_dependencies(teb_local_planner ${PROJECT_NAME}_generate_messages_cpp)

target_link_libraries(teb_local_planner
   ${EXTERNAL_LIBS}
   ${catkin_LIBRARIES}
)



## Build additional executables

add_executable(test_optim_node src/test_optim_node.cpp)

target_link_libraries(test_optim_node
   teb_local_planner
   ${EXTERNAL_LIBS}
   ${catkin_LIBRARIES}
)


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
install(TARGETS teb_local_planner
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)
install(TARGETS test_optim_node
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   #FILES_MATCHING PATTERN "*.h"
   PATTERN ".svn" EXCLUDE
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
  teb_local_planner_plugin.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(DIRECTORY
  launch cfg scripts
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  PATTERN ".svn" EXCLUDE
)

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_teb_local_planner.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-lunar-teb-local-planner (0.7.4-0xenial) xenial; urgency=high

  * bugfix in calculateHSignature. Fixes #90 <https://github.com/rst-tu-dortmund/teb_local_planner/issues/90>.
  * fixed centroid computation in a special case of polygon-obstacles
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Mon, 13 Aug 2018 22:00:00 -0000

ros-lunar-teb-local-planner (0.7.3-0xenial) xenial; urgency=high

  * Parameter switching_blocking_period added to homotopy class planner parameter group.
    Values greater than zero enforce the homotopy class planner to only switch to new equivalence classes as soon
    as the given period is expired (this might reduce oscillations in some scenarios). The value is set to zero seconds
    by default in order to not change the behavior of existing configurations.
  * Fixed unconsistent naming of parameter global_plan_viapoint_sep.
    The parameter retrieved at startup was global_plan_via_point_sep and via dynamic_reconfigure it was global_plan_viapoint_sep.
    global_plan_via_point_sep has now been replaced by global_plan_viapoint_sep since this is more consistent with the variable name
    in the code as well as weight_viapoint and the ros wiki description.
    In order to not break things, the old parameter name can still be used. However, a deprecated warning is printed.
  * transformGlobalPlan searches now for the closest point within the complete subset of the global plan in the local costmap:
    In every sampling interval, the global plan is processed in order to find the closest pose to the robot (as reference start)
    and the current end pose (either local at costmap boundary or max_global_plan_lookahead_dist).
    Previously, the search algorithm stopped as soon as the distance to the robot increased once.
    This caused troubles with more complex global plans, hence the new strategy checks the complete subset
    of the global plan in the local costmap for the closest distance to the robot.
  * via-points that are very close to the current robot pose or behind the robot are now skipped (in non-ordered mode)
  * Edge creation: minor performance improvement for dynamic obstacle edges
  * dynamic_reconfigure: parameter visualize_with_time_as_z_axis_scale moved to group trajectory
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Wed, 04 Jul 2018 22:00:00 -0000

ros-lunar-teb-local-planner (0.7.2-0xenial) xenial; urgency=high

  * Adds the possibility to provide via-points via a topic.
    Currently, the user needs to decide whether to receive via-points from topic or to obtain them from the global reference plan
    (e.g., activate the latter by setting global_plan_viapoint_sep>0 as before).
    A small test script publish_viapoints.py is provided to demonstrate the feature within test_optim_node.
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Thu, 07 Jun 2018 22:00:00 -0000

ros-lunar-teb-local-planner (0.7.1-0xenial) xenial; urgency=high

  * Fixed a crucial bug (from 0.6.6): A cost function for prefering a clockwise resp. anti-clockwise turn was enabled by default.
    This cost function was only intended to be active only for recovering from an oscillating robot.
    This cost led to a penalty for one of the turning directions and hence the maximum turning rate for the penalized direction could not be reached.
    Furthermore, which is more crucial: since the penalty applied only to a small (initial) subset of the trajectory, the overall control performance was poor
    (huge gap between planned motion and closed-loop trajectories led to frequent corrections of the robot pose and hence many motion reversals).
  * Adds support for circular obstacle types. This includes support for the radius field in costmap_converter::ObstacleMsg
  * rqt reconfigure: parameters are now grouped in tabs (robot, trajectory, viapoints, ...)
  * Update to use non deprecated pluginlib macro
  * Python scripts updated to new obstacle message definition.
  * Fixed issue when start and end are at the same location (PR #43)
  * Normalize marker quaternions in *test_optim_node*
  * Contributors: Christoph Rösmann, Alexander Reimann, Mikael Arguedas, wollip

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Mon, 04 Jun 2018 22:00:00 -0000

ros-lunar-teb-local-planner (0.7.0-0xenial) xenial; urgency=high

  * This update introduces support for dynamic obstacles (thanks to Franz Albers, who implemented and tested the code).
    Dynamic obstacle support requires parameter *include_dynamic_obstacles* to be activated.
    Note, this feature is still experimental and subject to testing.
    Motion prediction is performed using a constant velocity model.
    Dynamic obstacles might be incorporated as follows:
    * via a custom message provided on topic ~/obstacles (warning: we changed the message type from teb_local_planner/ObstacleMsg to costmap_converter/ObstacleArrayMsg).
    * via the CostmapToDynamicObstacles plugin as part of the costmap_converter package (still experimental).
    A tutorial is going to be provided soon.
  * FeedbackMsg includes a ObstacleMsg instead of a polygon
  * ObstacleMsg removed from package since it is now part of the costmap_converter package.
  * Homotopy class planer code update: graph search methods and equivalence classes (h-signatures) are now
    implemented as subclasses of more general interfaces.
  * TEB trajectory initialization now uses a max_vel_x argument instead of the desired time difference in order to give the optimizer a better warm start.
    Old methods are marked as deprecated. This change does not affect users settings.
  * Inplace rotations removed from trajectory initialization to improve convergence speed of the optimizer


=== debian/control ===
Source: ros-lunar-teb-local-planner
Section: misc
Priority: extra
Maintainer: Christoph Rösmann <christoph.roesmann@tu-dortmund.de>
Build-Depends: debhelper (>= 9.0.0), ros-lunar-base-local-planner, ros-lunar-catkin, ros-lunar-cmake-modules, ros-lunar-costmap-2d, ros-lunar-costmap-converter, ros-lunar-dynamic-reconfigure, ros-lunar-geometry-msgs, ros-lunar-interactive-markers, ros-lunar-libg2o, ros-lunar-message-generation, ros-lunar-nav-core, ros-lunar-nav-msgs, ros-lunar-pluginlib, ros-lunar-roscpp, ros-lunar-std-msgs, ros-lunar-tf, ros-lunar-tf-conversions, ros-lunar-visualization-msgs
Homepage: http://wiki.ros.org/teb_local_planner
Standards-Version: 3.9.2

Package: ros-lunar-teb-local-planner
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-lunar-base-local-planner, ros-lunar-costmap-2d, ros-lunar-costmap-converter, ros-lunar-dynamic-reconfigure, ros-lunar-geometry-msgs, ros-lunar-interactive-markers, ros-lunar-libg2o, ros-lunar-message-runtime, ros-lunar-nav-core, ros-lunar-nav-msgs, ros-lunar-pluginlib, ros-lunar-roscpp, ros-lunar-std-msgs, ros-lunar-tf, ros-lunar-tf-conversions, ros-lunar-visualization-msgs
Description: The teb_local_planner package implements a plugin to the base_local_planner of the 2D navigation stack.
 The underlying method called Timed Elastic Band locally optimizes the robot's trajectory with respect to trajectory execution time, separation from obstacles and compliance with kinodynamic constraints at runtime.
